;Example Bitblt and Bitmap-Creation
;Andy www.autoit.de
;Die verwendeten Funktionen und auskommentierten Funktionen hatte ich fr ein anderes Projekt erstellt
;Es ist noch reichlich Material z.B. zum Laden von Fonts und auch Laden von Bilddateien aller mglicher Formate vorhanden
;Blitten mit "echter" Transparenz (WinapiAlphaBlend() nur 32bit) usw.
;bei Interesse einfach melden

#include <WindowsConstants.au3>
#include <WinAPI.au3>
#include <gdiplus.au3>                          ;kann bei Verwendung einer 32- oder 24- Bit-Bitmap als Hintergrund weggelassen werden
;#include <WinAPIEX.au3>  von Yashied sollte man haben ^^, dann kann man sich die letzten Funktionen in diesem script sparen


Opt("GUIOnEventMode", 1)


Const $iBitCount = 32                           ;Bit per Pixel (8,16,24 oder 32) fr die Bitmaps
Const $factor = $iBitCount / 8

Global Const $pi_div_180 = 4 * ATan(1) / 180    ;

$radius = 60                                    ;fr die Darstellung des rotierenden Hintergrundes

Global $winx = 900                              ;Fenstergre
Global $winy = 650

Global $stride, $height, $width, $bitmap, $ptr, $pbitmap, $pixelptr, $pixelstruct
Global $iwidth, $iheight, $ptr, $ptr2, $ptr3, $hgui, $ptr4, $hdc, $adib, $hcdc
Global $FPS, $buttonflag = 0, $a


Local $ptr1, $ptr2
Local $hgui = GUICreate("", $winx, $winy)       ; @DesktopWidth, @DesktopHeight)
$btn = GUICtrlCreateButton("Spiralen", 20, 20, 100, 30)
GUISetOnEvent(-3, "_Exit")
GUISetState()
Local $hDC_gui = _WinAPI_GetDC($hgui)           ;DeviceContext des Fensters holen

;einige Sprites erstellen, das dauert ^^
Local $anz_sprites = 50                         ;anzahl der sprites jeweils Donuts und Spiralen
Dim $hDC_Sprites[($anz_sprites + 1) * 2]        ;DCs der sprites
Dim $sx[($anz_sprites + 1) * 2]                 ;x- und y-Position der Sprites
Dim $sy[($anz_sprites + 1) * 2]
Dim $stepy[($anz_sprites + 1) * 2]              ;"geschwindigkeit" der Sprites
Dim $stepx[($anz_sprites + 1) * 2]

$donutaussen = 32                               ;radius aussen
$donutinnen = 15                                ;radius innen
$maxsteps = 4                                   ;maximale schrittweite der einzelnen sprites => geschwindigkeit

;Hintergrunddatei laden, man erhlt den DC, einen pointer auf die Bitmapdaten und fr GDI+ das Handle
Local $ptr_Hintergrund, $hwnd_Hintergrund       ;byref
Local $ptr_Buffer, $hwnd_Buffer                 ;byref
;;;;;;;;;;;;;ENTWEDER ganz ohne GDI+
If FileExists(@ScriptDir & "\mona-lisa.bmp") Then
    Local $hDC_hintergrund = LoadBitmapToDC("mona-lisa.bmp", $ptr_Hintergrund, $hwnd_Hintergrund) ;hintergrund laden
    ;Buffer laden, man erhlt den DC, einen pointer auf die Bitmapdaten und fr GDI+ das Handle
    Local $hDC_Buffer = LoadBitmapToDC("mona-lisa.bmp", $ptr_Buffer, $hwnd_Buffer) ;Buffer laden
ElseIf FileExists(@ScriptDir & "\mona-lisa.jpg") Then ;;;ODER GDI+ nur zum Laden des Hintergrundbildes
    _GDIPlus_Startup()                          ;braucht man nur, um jpgs oder andere Bildformate zu laden, bmps brauchen kein gdi+
    Local $hDC_hintergrund = getDCfromfile("mona-lisa.jpg", $ptr_Hintergrund) ;GDI+ ldt auch jpg
    Local $hDC_Buffer = getDCfromfile("mona-lisa.jpg", $ptr_Buffer)
    _GDIPlus_Shutdown()
Else
    MsgBox(0, "Fehler", "Kein Hintergrund geladen")
EndIf

$iwidth = $donutaussen * 2 + $maxsteps + 1      ;breite und hhe der sprites
$iheight = $donutaussen * 2 + $maxsteps + 1


For $i = 1 To $anz_sprites * 2                  ;donuts in mehreren Farben erstellen....das dauert^^
    $hDC_Sprites[$i] = _CreateNewPic($iheight, $iwidth, 0x0000FA) ;neues sprite erstellen (hhe, breite, hintergrundfarbe)
    $col = Random(1000, 0xFFFFFF, 1)
    If $i > $anz_sprites Then                   ;die hlfte spiralen
        Spiral($iheight / 2, $iwidth / 2, $donutaussen, 1200, 6, 0, $col) ;4 Spiralen, eine wre zu "dnn"
        Spiral($iheight / 2 + 1, $iwidth / 2 + 1, $donutaussen, 1200, 6, 0, $col) ;strichstrke geschummelt^^
        Spiral($iheight / 2 + 1, $iwidth / 2, $donutaussen, 1200, 6, 0, $col)
        Spiral($iheight / 2, $iwidth / 2 + 1, $donutaussen, 1200, 6, 0, $col)
    Else                                        ;die andere hlfte donuts
        filledcircle(Int($iwidth / 2), Int($iheight / 2), $donutaussen, $col) ;Donut "zeichnen"
        filledcircle(Int($iwidth / 2), Int($iheight / 2), $donutinnen, 0x0000FA) ;donut mit Hintergrundfarbe fllen
        $sx[$i] = Random(30, $winx - $donutaussen * 2, 1) ;zufllige startposition
        $sy[$i] = Random(30, $winy - $donutaussen * 2, 1)
        $stepx[$i] = Random(-$maxsteps, $maxsteps, 1) ;zufllige schrittweite = geschwindigkeit
        $stepy[$i] = Random(-$maxsteps, $maxsteps, 1)
    EndIf
    WinSetTitle($hgui, "", "Erstellen von " & $anz_sprites * 2 & " verschiedenen Sprites.  Bitte warten   " & Int(50 * $i / $anz_sprites) & "%")
Next


$hDC_Button = _CreateNewPic(100, 30, 0x0000FA)  ;platz fr den Button machen, hintergrund egal
;$WM_PAINT = 0x000F
GUICtrlSendMsg($btn, $WM_paint, $hDC_Button, 0) ;button in DC kopieren. geht auch mit allen anderen controls. da Hintergrund transparent, auch Fonts machbar

GUICtrlSetOnEvent($btn, "_Button")

AdlibRegister("_FPS", 1000)                     ;frames pro sekunde

;~ ;alternativ auch so...fensterinhalt kann mitbewegt werden
GUIRegisterMsg(0x0113, "_Draw")                 ;$WM_TIMER = 0x0113
DllCall("User32.dll", "int", "SetTimer", "hwnd", $hgui, "int", 0, "int", 10, "int", 0)
While 1
    Sleep(500)
WEnd



;die eigentliche Zeichenfunktion des kompletten Fensterinhalts
Func _draw()
    $a += 0.5                                   ;hintergrund rotieren im Winkel von 0,5 grad
    If $a > 360 Then $a = 0                     ;bei 360 wieder neu anfangen
    $p = $radius + Cos($a * $pi_div_180) * $radius ;position des rotierenden Hintergrundes
    $q = $radius + Sin($a * $pi_div_180) * $radius
    _WinAPI_BitBlt($hDC_Buffer, 0, 0, $winx, $winy, $hDC_hintergrund, $p, $q, $srccopy) ;Hintergrund in buffer
    For $i = 1 To $anz_sprites                  ;positionen aller sprites
        $t = $i + ($buttonflag * $anz_sprites)  ;je nach button donuts oder spiralen
        $stepx[$i] = $stepx[$i] * (-2 * (($sx[$i] < 3) Or ($sx[$i] > $winx - 2 * $donutaussen)) + 1) ;falls rand berhrt, richtung umkehren
        $stepy[$i] = $stepy[$i] * (-2 * (($sy[$i] < 3) Or ($sy[$i] > $winy - 2 * $donutaussen)) + 1) ;die folgenden 4 auskommentierten Zeilen machen das selbe etwas deutlicher^^
        ;If $sx[$i] < 3 Then $stepx[$i] = -$stepx[$i]
        ;If $sy[$i] < 3 Then $stepy[$i] = -$stepy[$i]
        ;If $sx[$i] > $winx - 2 * $donutaussen Then $stepx[$i] = -$stepx[$i]
        ;If $sy[$i] > $winy - 2 * $donutaussen Then $stepy[$i] = -$stepy[$i]
        $sx[$i] += $stepx[$i]                   ;neue x- und y-position der sprites
        $sy[$i] += $stepy[$i]
        _WinAPI_TransparentBlt($hDC_Buffer, $sx[$i], $sy[$i], $iwidth, $iheight, $hDC_Sprites[$t], 0, 0, $iwidth, $iheight, 0x0000FA) ;sprite in buffer
    Next
    _WinAPI_BitBlt($hDC_Buffer, 20, 20, 100, 30, $hDC_Button, 0, 0, $srccopy) ;Button in buffer
    $t = TimerInit()
    _WinAPI_BitBlt($hDC_gui, 0, 0, $winx, $winy, $hDC_Buffer, 0, 0, $srccopy) ;buffer in window
    $m = TimerDiff($t)
    ConsoleWrite('@@ Debug(' & @ScriptLineNumber & ') : $m = ' & $m & @CRLF & '>Error code: ' & @error & @CRLF) ;### Debug Console

    $FPS += 1                                   ;frames pro sekunde
EndFunc                                         ;==>_draw



Func _FPS()                                     ;frames pro sekunde
    WinSetTitle($hgui, "", "FPS = " & $FPS & "     Sprites:" & $anz_sprites & "     Bitte Fenster bewegen, der Inhalt bewegt sich weiter!")
    $FPS = 0
EndFunc                                         ;==>_FPS

Func _Button()
    If GUICtrlRead($btn) = "Spiralen" Then
        GUICtrlSetData($btn, "Donuts")
        GUICtrlSendMsg($btn, $WM_paint, $hDC_Button, 0) ;button in DC
        $buttonflag = 1
    Else
        GUICtrlSetData($btn, "Spiralen")
        GUICtrlSendMsg($btn, $WM_paint, $hDC_Button, 0) ;button in DC
        $buttonflag = 0
    EndIf
EndFunc                                         ;==>_Button

Func _FPS_Begrenzer($frames)
    If $frames < $FPS Then Return

EndFunc                                         ;==>_FPS_Begrenzer

Func _CreateNewPic($iwidth, $iheight, $backcolor = 0x000000) ;erstellt leere Bitmap; Rckgabe $HDC und $ptr auf die Bitmapdaten
    $hbmp = _WinAPI_CreateBitmap($iwidth, $iheight) ;"leere" bitmap vorbereiten
    $tBMI = DllStructCreate($tagBITMAPINFO)     ;bitmapheader
    DllStructSetData($tBMI, 1, DllStructGetSize($tBMI) - 4) ;header fllen
    DllStructSetData($tBMI, 2, $iwidth)
    DllStructSetData($tBMI, 3, -$iheight)
    DllStructSetData($tBMI, 4, 1)
    DllStructSetData($tBMI, 5, $iBitCount) ;bit per pixel
    $hdc = _WinAPI_GetDC(0)                     ;DC vom Desktop holen
    $hcdc = _WinAPI_CreateCompatibleDC($hdc)    ;DC kopieren
    ;Bitmap erstellen, um DC, Pointer zu den Bitmapdaten und handle fr GDI+-Funktionen zu erhalten
    $adib = DllCall('gdi32.dll', 'ptr', 'CreateDIBSection', 'ptr', 0, 'ptr', DllStructGetPtr($tBMI), 'uint', 1, 'ptr*', 0, 'ptr', 0, 'uint', 0)
    _WinAPI_SelectObject($hcdc, $adib[0])
    _WinAPI_GetDIBits($hdc, $hbmp, 0, $iheight, $adib[4], DllStructGetPtr($tBMI), 1)
    $stride = ($iBitCount / 8) * $iwidth        ;abhngig von der breite des bildes die fillbytes bestimmen
    If Mod(($iBitCount / 8) * $iwidth, 4) <> 0 Then $stride += 4 - Mod(($iBitCount / 8) * $iwidth, 4)
    $bitmap = DllStructCreate('byte[' & $stride * $iheight & ']', $adib[4])
    $ptr = DllStructGetPtr($bitmap)
    $height = $iheight
    $width = $iwidth
    _WinAPI_DeleteObject($adib[0])
    If $backcolor <> 0x000000 Then              ;falls Hintergrundfarbe nicht schwarz, hintergrund fllen
        For $i = 1 To $height
            Line(1, $i, $width, $i, $backcolor)
        Next
    EndIf
    Return $hcdc                                ;MemoryDC
EndFunc                                         ;==>_CreateNewPic

Func _Exit()
    ;_WinAPI_DeleteObject($adib[0])
    _WinAPI_DeleteDC($hcdc)
    _WinAPI_DeleteDC($hDC_gui)
    _WinAPI_DeleteDC($hDC_hintergrund)
    _WinAPI_DeleteDC($hDC_Buffer)
    _WinAPI_ReleaseDC(0, $hdc)
    Exit
EndFunc                                         ;==>_Exit


;GDI+ wird nur verwendet, um andere Dateien als das BMP-Format zu laden
Func getDCfromfile($bmpfile, ByRef $ptr)        ;ptr to bitmapdata, it is possible to manipulate one pixel if needed
    $hbitmap = _GDIPlus_BitmapCreateFromFile($bmpfile)
    $hbmp = _GDIPlus_BitmapCreateHBITMAPFromBitmap($hbitmap)
    $iwidth = _GDIPlus_ImageGetWidth($hbitmap)
    $iheight = _GDIPlus_ImageGetHeight($hbitmap)

    $tBMI = DllStructCreate($tagBITMAPINFO)
    DllStructSetData($tBMI, 1, DllStructGetSize($tBMI) - 4)
    DllStructSetData($tBMI, 2, $iwidth)
    DllStructSetData($tBMI, 3, -$iheight)
    DllStructSetData($tBMI, 4, 1)
    DllStructSetData($tBMI, 5, $iBitCount)
    $hdc = _WinAPI_GetDC(0)
    $hcdc = _WinAPI_CreateCompatibleDC($hdc)
    $adib = DllCall('gdi32.dll', 'ptr', 'CreateDIBSection', 'ptr', 0, 'ptr', DllStructGetPtr($tBMI), 'uint', 1, 'ptr*', 0, 'ptr', 0, 'uint', 0)

    ; select object
    _WinAPI_SelectObject($hcdc, $adib[0])

    ; copy the content of the bitmap into the buffer ...
    _WinAPI_GetDIBits($hdc, $hbmp, 0, $iheight, $adib[4], DllStructGetPtr($tBMI), 1)

    ; create the a dllstruct with the pointer $aDIB[4]
    $stride = 3 * $iwidth + Mod($iwidth, 4)     ;number of bytes in one line (filled with some bytes, because it must be a multiple of four!)
    $tBits = DllStructCreate('byte[' & $stride * $iheight & ']', $adib[4])
    $ptr = DllStructGetPtr($tBits)
    _GDIPlus_BitmapDispose($hbitmap)
    _WinAPI_DeleteObject($adib[0])
    Return $hcdc                                ;MemoryDC of bitmap
EndFunc                                         ;==>getDCfromfile


;~ Func _showpic($file)
;~     ShellExecute($file)
;~ EndFunc   ;==>_showpic


;~ Func _CreateNewPicx($w, $h, $backcolor = 0x000000)
;~     $height = $h
;~     $width = $w
;~     $stride = 3 * $width + Mod($width, 4) ;number of bytes in one line (filled with some bytes, because it must be a multiple of four!)
;~     $size = $stride * $height ;size of the bitmapdata
;~     $bitmap = DllStructCreate("ubyte [" & 54 + $stride * $height & "]") ;54 is lenght of bitmapheader
;~     $ptr = DllStructGetPtr($bitmap)
;~     _WriteBMPHeader24($width, $height, $bitmap) ;headerdata
;~     If $backcolor <> 0x000000 Then
;~         For $i = 1 To $height
;~             Line(1, $i, $width, $i, $backcolor)
;~         Next
;~     EndIf
;~     Return $ptr
;~ EndFunc   ;==>_CreateNewPicx

;~ Func _WriteNewPicToFile($bmpfile)
;~     $filehandle = FileOpen($bmpfile, 18) ;write file
;~     FileWrite($filehandle, DllStructGetData($bitmap, 1))
;~     FileClose($filehandle)
;~ EndFunc   ;==>_WriteNewPicToFile

;~ Func _WriteBMPHeader24($width, $height, $head) ;head is the name of the bitmap-struct
;~     ;$stride     = 3 * $width + mod($width,4)    ;number of bytes in one line filled with bytes,  because it must be a multiple of four!
;~     $size = $stride * $height ;size of the bitmapdata
;~     $Bmpheader = DllStructCreate("align 1;char BM[2];uint Size;uint Res;uint Offset;uint BMHI;" & _
;~             "uint Width;uint Height;short Planes;short BPP;uint BIcomp;" & _
;~             "int SizeImg;uint ResHor;uint ResVer;uint Colors;uint ColorsUsed", DllStructGetPtr($head)) ;struct of bytes = header of bitmap #1
;~     ;fill struct(bitmapheader) with data
;~     DllStructSetData($Bmpheader, "BM", "BM") ;2 Byte Ascii "BM" BitMap
;~     DllStructSetData($Bmpheader, "Size", 54 + $size) ;4 bytes size of bitmapfile (unreliable)
;~     DllStructSetData($Bmpheader, "Res", 0) ;4 bytes Reserved/Unused
;~     DllStructSetData($Bmpheader, "Offset", 54) ;4 bytes Offset of the bitmapdata from begin of file
;~     DllStructSetData($Bmpheader, "BMHI", 40) ;4 bytes size of bitmapinfoheader-struct (40Bytes)
;~     DllStructSetData($Bmpheader, "Width", $width) ;4 bytes width of bitmap in pixel
;~     DllStructSetData($Bmpheader, "Height", $height) ;4 bytes height of bitmap in pixel, negativ because "bottom up"
;~     DllStructSetData($Bmpheader, "Planes", 1) ;2 bytes number of colour planes
;~     DllStructSetData($Bmpheader, "BPP", 24) ;2 bytes number of bits per pixel
;~     DllStructSetData($Bmpheader, "BIcomp", 0) ;4 bytes Compression
;~     DllStructSetData($Bmpheader, "SizeImg", $size) ;4 bytes size of imagedata in bytes
;~     DllStructSetData($Bmpheader, "ResHor", 0) ;4 bytes resolution horizontal in pixel/meter
;~     DllStructSetData($Bmpheader, "ResVer", 0) ;4 bytes resolution vertical in pixel/meter
;~     DllStructSetData($Bmpheader, "Colors", 0) ;4 bytes number of palette colours
;~     DllStructSetData($Bmpheader, "ColorsUsed", 0) ;4 bytes number of all colours used in the image
;~     ;return dllstructgetdata($head)                    ;pointer to headerdata
;~ EndFunc   ;==>_WriteBMPHeader24

Func circle($x1, $y1, $r, $color)               ;xcenter;ycenter;radius
    $s = 0.0174532925199433                     ;   4*atan(1)/180
    For $a = 0 To 1.5707963267949 Step $s / 4
        $y = Round(Sin($a) * $r)
        $x = Round(Cos($a) * $r)
        paintpixel($x1 + $x, $y1 - $y, $color)
        paintpixel($x1 - $x, $y1 - $y, $color)
        paintpixel($x1 + $x, $y1 + $y, $color)
        paintpixel($x1 - $x, $y1 + $y, $color)
    Next
EndFunc                                         ;==>circle

Func filledcircle($x1, $y1, $r, $color)         ;xcenter;ycenter;radius
    $s = 0.0174532925199433                     ;   4*atan(1)/180
    For $a = 0 To 1.5707963267949 Step $s / 4
        $y = Round(Sin($a) * $r)
        $x = Round(Cos($a) * $r)
        Line($x1 + $x, $y1 - $y, $x1 - $x, $y1 - $y, $color)
        Line($x1 + $x, $y1 + $y, $x1 - $x, $y1 + $y, $color)
    Next
EndFunc                                         ;==>filledcircle


Func Spiral($centerX, $centerY, $radius, $sides, $coils, $rotation, $color)
    $pi = 4 * ATan(1)
    $awayStep = $radius / $sides
    $aroundStep = $coils / $sides
    $aroundRadians = $aroundStep * 2 * $pi
    $rotation *= 2 * $pi
    For $i = 1 To $sides
        $away = $i * $awayStep
        $around = $i * $aroundRadians + $rotation
        $x = Int($centerX + Cos($around) * $away) ;x
        $y = Int($centerY + Sin($around) * $away) ; and y-coordinates of the pixel
        paintpixel($x, $y, $color)
    Next
EndFunc                                         ;==>Spiral

Func Line($x1, $y1, $x2, $y2, $color)           ;y=mx+b

    If $x2 = $x1 Then                           ;senkrechte linie
        $Step = 1
        If $y2 < $y1 Then $Step = -1
        For $yy = $y1 To $y2 Step $Step
            paintpixel($x1, $yy, $color)
        Next
        Return
    EndIf

    If $y2 = $y1 Then                           ;waagrechte linie
        If $x2 < $x1 Then
            $d = $x1
            $x1 = $x2
            $x2 = $d
        EndIf
        $lenght = Abs($x2 - $x1) + 1            ;anzahl bytes der linie
        $m = $factor * $lenght
        $position = $stride * ($height - $y1) + $factor * ($x1 - 1) ;this is the position of the pixel in the file!
        $linestruct = DllStructCreate("byte[" & $m & "]", $ptr + $position)
        $col = StringLeft(BinaryToString($color), $factor)
        While StringLen($col) * 2 <= $m
            $col &= $col
        WEnd
        $col &= StringLeft($col, $m - StringLen($col))
        DllStructSetData($linestruct, 1, $col)
        Return
    Else
        $m = ($y2 - $y1) / ($x2 - $x1)
    EndIf

    $b = $y1 - $m * $x1

    If Abs($m) <= 1 Then
        $Step = -1
        If $x1 < $x2 Then $Step = 1

        For $xx = $x1 To $x2 Step $Step
            $yy = Round($m * $xx + $b)
            paintpixel($xx, $yy, $color)
        Next
    Else
        $Step = -1
        If $y1 < $y2 Then $Step = 1
        For $yy = $y1 To $y2 Step $Step
            $xx = Round(($yy - $b) / $m)
            paintpixel($xx, $yy, $color)
        Next
    EndIf
EndFunc                                         ;==>Line


Func paintpixel($x, $y, $color)
    $position = $stride * ($height - $y) + $factor * $x ;this is the position of the pixel in the struct!
    $substruct = DllStructCreate("byte [3]", $ptr + $position) ;writes a 3-byte struct at position of the pixel
    DllStructSetData($substruct, 1, $color)     ;writes the 3-byte colour into the struct at the position of the pixel
    $substruct = 0
EndFunc                                         ;==>paintpixel

;Rckgabe DC, Pointer fr die Bitmapdaten und Handle fr GDI+, alles unabhngig voneinander verwendbar!
Func LoadBitmapToDC($file, ByRef $ptr, ByRef $hbmp) ;32/24 Bpp-bitmaps ohne palette

    ;fill struct(bitmapheader) with data
;~     DllStructSetData($Bmpheader, "BM", "BM")             ;2 Byte Ascii "BM" BitMap
;~     DllStructSetData($Bmpheader, "Size", 54 + $size)     ;4 bytes size of bitmapfile (unreliable)
;~     DllStructSetData($Bmpheader, "Res", 0)                 ;4 bytes Reserved/Unused
;~     DllStructSetData($Bmpheader, "Offset", 54)             ;4 bytes Offset of the bitmapdata from begin of file
;~     DllStructSetData($Bmpheader, "BMHI", 40)             ;4 bytes size of bitmapinfoheader-struct (40Bytes)
;~     DllStructSetData($Bmpheader, "Width", $width)         ;4 bytes width of bitmap in pixel
;~     DllStructSetData($Bmpheader, "Height", $height)     ;4 bytes height of bitmap in pixel, negativ because "bottom up"
;~     DllStructSetData($Bmpheader, "Planes", 1)             ;2 bytes number of colour planes
;~     DllStructSetData($Bmpheader, "BPP", 24)             ;2 bytes number of bits per pixel
;~     DllStructSetData($Bmpheader, "BIcomp", 0)             ;4 bytes Compression
;~     DllStructSetData($Bmpheader, "SizeImg", $size)         ;4 bytes size of imagedata in bytes
;~     DllStructSetData($Bmpheader, "ResHor", 0)             ;4 bytes resolution horizontal in pixel/meter
;~     DllStructSetData($Bmpheader, "ResVer", 0)             ;4 bytes resolution vertical in pixel/meter
;~     DllStructSetData($Bmpheader, "Colors", 0)             ;4 bytes number of palette colours
;~     DllStructSetData($Bmpheader, "ColorsUsed", 0)         ;4 bytes number of all colours used in the image

    $data = FileRead($file)                     ;bmp-datei einlesen
    $bitmapdata = StringToBinary(StringTrimLeft($data, 54)) ;header abschneiden
    $header = StringToBinary(StringLeft($data, 54)) ;header holen
    $Bmpheader = DllStructCreate("align 1;char BM[2];uint Size;uint Res;uint Offset;uint BMHI;" & _
            "uint Width;uint Height;short Planes;short BPP;uint BIcomp;" & _
            "int SizeImg;uint ResHor;uint ResVer;uint Colors;uint ColorsUsed") ;struct of bytes = header of bitmap #1
    $headerstruct = DllStructCreate("byte[54]", DllStructGetPtr($Bmpheader))
    DllStructSetData($headerstruct, 1, $header)

    $width = DllStructGetData($Bmpheader, "Width") ;4 bytes width of bitmap in pixel
    $height = DllStructGetData($Bmpheader, "Height") ;4 bytes height of bitmap in pixel, negativ because "bottom up"
    $BPP = DllStructGetData($Bmpheader, "BPP")  ;BitsPerPixel

    If Not IsDeclared("tagBITMAPINFO") Then Assign("tagBITMAPINFO", "dword Size;long Width;long Height;word Planes;word BitCount;dword Compression;dword SizeImage;" & _
            "long XPelsPerMeter;long YPelsPerMeter;dword ClrUsed;dword ClrImportant;dword RGBQuad")
    $hbmp = _WinAPI_CreateBitmap($width, $height) ;"leere" bitmap vorbereiten
    $tBMI = DllStructCreate($tagBITMAPINFO)     ;bitmapheader
    DllStructSetData($tBMI, "Size", DllStructGetSize($tBMI) - 4) ;header fllen
    DllStructSetData($tBMI, "Width", $width)
    DllStructSetData($tBMI, "Height", $height)  ;minus fr bottom-up
    DllStructSetData($tBMI, "Planes", 1)
    DllStructSetData($tBMI, "BitCount", $BPP)   ;bit per pixel
    $hdc = _WinAPI_GetDC(0)                     ;DC vom Desktop holen
    $hcdc = _WinAPI_CreateCompatibleDC($hdc)    ;DC kopieren
    ;Bitmap erstellen, um DC, Pointer zu den Bitmapdaten und handle fr GDI+-Funktionen zu erhalten
    $adib = DllCall('gdi32.dll', 'ptr', 'CreateDIBSection', 'ptr', 0, 'ptr', DllStructGetPtr($tBMI), 'uint', 1, 'ptr*', 0, 'ptr', 0, 'uint', 0)
    _WinAPI_SelectObject($hcdc, $adib[0])
    _WinAPI_GetDIBits($hdc, $hbmp, 0, $iheight, $adib[4], DllStructGetPtr($tBMI), 1)
    _WinAPI_DeleteObject($adib[0])
    $stride = ($BPP / 8) * $width               ;abhngig von der breite des bildes die fillbytes bestimmen
    If Mod(($BPP / 8) * $width, 4) <> 0 Then $stride += 4 - Mod(($BPP / 8) * $width, 4)
    $struct_BMP = DllStructCreate("byte[" & $stride * $height & "]", $adib[4])
    DllStructSetData($struct_BMP, 1, $bitmapdata) ;daten aus Datei in Speicher
    $ptr = DllStructGetPtr($struct_BMP)         ;pointer auf die Pixel
    Return $hcdc                                ;MemoryDC
EndFunc                                         ;==>LoadBitmapToDC





; #FUNCTION# ====================================================================================================================
; Name...........: _WinAPI_TransparentBlt
; Description....: Performs a bit-block transfer of the color data corresponding to a rectangle of pixels.
; Syntax.........: _WinAPI_TransparentBlt ( $hDestDC, $iXDest, $iYDest, $iWidthDest, $iHeightDest, $hSrcDC, $iXSrc, $iYSrc, $iWidthSrc, $iHeightSrc, $iRGB )
; Parameters.....: $hDestDC     - Handle to the destination device context.
;                  $iXDest      - The x-coordinate, in logical units, of the upper-left corner of the destination rectangle.
;                  $iYDest      - The y-coordinate, in logical units, of the upper-left corner of the destination rectangle.
;                  $iWidthDest  - The width, in logical units, of the destination rectangle.
;                  $iHeightDest - The height, in logical units, of the destination rectangle.
;                  $hSrcDC      - Handle to the source device context.
;                  $iXSrc       - The x-coordinate, in logical units, of the upper-left corner of the source rectangle.
;                  $iYSrc       - The y-coordinate, in logical units, of the upper-left corner of the source rectangle.
;                  $iWidthSrc   - The width, in logical units, of the source rectangle.
;                  $iHeightSrc  - The height, in logical units, of the source rectangle.
;                  $iRGB        - The RGB color in the source bitmap to treat as transparent.
; Return values..: Success      - 1.
;                  Failure      - 0 and sets the @error flag to non-zero.
; Author.........: Yashied
; Modified.......:
; Remarks........: If the source and destination rectangles are not the same size, the source bitmap is stretched to match the
;                  destination rectangle. When the _WinAPI_SetStretchBltMode() function is used, the stretching modes of
;                  $BLACKONWHITE and $WHITEONBLACK are converted to $COLORONCOLOR for the _WinAPI_TransparentBlt() function.
;
;                  This function supports all formats of source bitmaps. However, for 32 bpp bitmaps, it just copies the alpha
;                  value over. Use _WinAPI_AlphaBlend() to specify 32 bits-per-pixel bitmaps with transparency.
; Related........:
; Link...........: @@MsdnLink@@ GdiTransparentBlt
; Example........: Yes
; ===============================================================================================================================

;~ Func _WinAPI_TransparentBlt($hDestDC, $iXDest, $iYDest, $iWidthDest, $iHeightDest, $hSrcDC, $iXSrc, $iYSrc, $iWidthSrc, $iHeightSrc, $iRGB)

;~     Local $Ret = DllCall('gdi32.dll', 'int', 'GdiTransparentBlt', 'hwnd', $hDestDC, 'int', $iXDest, 'int', $iYDest, 'int', $iWidthDest, 'int', $iHeightDest, 'hwnd', $hSrcDC, 'int', $iXSrc, 'int', $iYSrc, 'int', $iWidthSrc, 'int', $iHeightSrc, 'dword', __IsRGB($iRGB))

;~     If (@error) Or (Not $Ret[0]) Then
;~         Return SetError(1, 0, 0)
;~     EndIf
;~     Return 1
;~ EndFunc                                         ;==>_WinAPI_TransparentBlt

Func __IsRGB($iColor)                           ;auch aus der WinApiEX von Yashied
    $__RGB = True                               ;konstante aus der WinApiEX von Yashied
    If $__RGB Then
        $iColor = _WinAPI_SwitchColor($iColor)
    EndIf
    Return $iColor
EndFunc                                         ;==>__IsRGB

; #FUNCTION# ====================================================================================================================
; Name...........: _WinAPI_SwitchColor
; Description....: Converts a color from BGR to RGB and vice versa.
; Syntax.........: _WinAPI_SwitchColor ( $iColor )
; Parameters.....: $iColor - The color to conversion.
; Return values..: Converted color (RGB or BGR - depends on the $iColor value, BGR > RGB > BGR etc).
; Author.........: Yashied
; Modified.......:
; Remarks........: None
; Related........:
; Link...........: None
; Example........: Yes
; ===============================================================================================================================

;~ Func _WinAPI_SwitchColor($iColor)
;~     Return BitOR(BitAND($iColor, 0x00FF00), BitShift(BitAND($iColor, 0x0000FF), -16), BitShift(BitAND($iColor, 0xFF0000), 16))
;~ EndFunc                                         ;==>_WinAPI_SwitchColor




